summaryrefslogtreecommitdiff
path: root/cmdline
diff options
context:
space:
mode:
authorMichael Vogt <michael.vogt@ubuntu.com>2010-01-08 22:28:49 +0100
committerMichael Vogt <michael.vogt@ubuntu.com>2010-01-08 22:28:49 +0100
commit46e39c8e14dc98045107cfb38af8cecb8a4773b0 (patch)
treefc51ea417acab91f22e968f1fe7e5e0eb1a23b56 /cmdline
parent48b78442a60faf567390eab4372fe3e06c183e73 (diff)
* French manpage translation update
* spot & fix various typos in all manpages * German manpage translation update * cmdline/apt-cache.cc: - remove translatable marker from the "%4i %s\n" string * buildlib/po4a_manpage.mak: - instruct debiandoc to build files with utf-8 encoding * buildlib/tools.m4: - fix some warning from the buildtools * apt-pkg/acquire-item.cc: - add configuration PDiffs::Limit-options to not download too many or too big patches (Closes: #554349) * debian/control: - let all packages depend on ${misc:Depends} * share/*-archive.gpg: - remove the horrible outdated files. We already depend on the keyring so we don't need to ship our own version * cmdline/apt-key: - errors out if wget is not installed (Closes: #545754) - add --keyring option as we have now possibly many * methods/gpgv.cc: - pass all keyrings (TrustedParts) to gpgv instead of using only one trusted.gpg keyring (Closes: #304846) * methods/https.cc: - finally merge the rest of the patchset from Arnaud Ebalard with the CRL and Issuers options, thanks! (Closes: #485963)
Diffstat (limited to 'cmdline')
-rw-r--r--cmdline/apt-cache.cc2
-rwxr-xr-xcmdline/apt-key47
2 files changed, 43 insertions, 6 deletions
diff --git a/cmdline/apt-cache.cc b/cmdline/apt-cache.cc
index 7d7f58a62..286f306cd 100644
--- a/cmdline/apt-cache.cc
+++ b/cmdline/apt-cache.cc
@@ -1620,7 +1620,7 @@ bool Policy(CommandLine &CmdL)
if (SrcList->FindIndex(VF.File(),Indx) == false &&
_system->FindIndex(VF.File(),Indx) == false)
return _error->Error(_("Cache is out of sync, can't x-ref a package file"));
- printf(_(" %4i %s\n"),Plcy.GetPriority(VF.File()),
+ printf(" %4i %s\n",Plcy.GetPriority(VF.File()),
Indx->Describe(true).c_str());
}
}
diff --git a/cmdline/apt-key b/cmdline/apt-key
index 5f4e02fdf..e45468fd4 100755
--- a/cmdline/apt-key
+++ b/cmdline/apt-key
@@ -5,10 +5,8 @@ unset GREP_OPTIONS
# We don't use a secret keyring, of course, but gpg panics and
# implodes if there isn't one available
-
GPG_CMD="gpg --ignore-time-conflict --no-options --no-default-keyring --secret-keyring /etc/apt/secring.gpg --trustdb-name /etc/apt/trustdb.gpg"
-GPG="$GPG_CMD --keyring /etc/apt/trusted.gpg"
-
+GPG="$GPG_CMD"
MASTER_KEYRING=""
ARCHIVE_KEYRING_URI=""
@@ -56,7 +54,14 @@ add_keys_with_verify_against_master_keyring() {
# (otherwise it does not make sense from a security POV)
net_update() {
if [ -z "$ARCHIVE_KEYRING_URI" ]; then
- echo "ERROR: no location for the archive-keyring given"
+ echo "ERROR: no location for the archive-keyring given"
+ exit 1
+ fi
+ # in theory we would need to depend on wget for this, but this feature
+ # isn't useable in debian anyway as we have no keyring uri nor a master key
+ if ! which wget >/dev/null 2>&1; then
+ echo "ERROR: an installed wget is required for a network-based update"
+ exit 1
fi
if [ ! -d /var/lib/apt/keyrings ]; then
mkdir -p /var/lib/apt/keyrings
@@ -108,7 +113,7 @@ update() {
usage() {
- echo "Usage: apt-key [command] [arguments]"
+ echo "Usage: apt-key [--keyring file] [command] [arguments]"
echo
echo "Manage apt's list of trusted keys"
echo
@@ -122,8 +127,40 @@ usage() {
echo " apt-key finger - list fingerprints"
echo " apt-key adv - pass advanced options to gpg (download key)"
echo
+ echo "If no specific keyring file is given the command applies to all keyring files."
}
+# Determine on which keyring we want to work
+if [ "$1" = "--keyring" ]; then
+ #echo "keyfile given"
+ shift
+ TRUSTEDFILE="$1"
+ if [ -r "$TRUSTEDFILE" ]; then
+ GPG="$GPG --keyring $TRUSTEDFILE --primary-keyring $TRUSTEDFILE"
+ else
+ echo >&2 "Error: The specified keyring »$TRUSTEDFILE« is missing or not readable"
+ exit 1
+ fi
+ shift
+# otherwise use the default
+else
+ #echo "generate list"
+ TRUSTEDFILE="/etc/apt/trusted.gpg"
+ if [ -r "$TRUSTEDFILE" ]; then
+ GPG="$GPG --keyring $TRUSTEDFILE"
+ fi
+ GPG="$GPG --primary-keyring $TRUSTEDFILE"
+ TRUSTEDPARTS="/etc/apt/trusted.gpg.d"
+ if [ -d "$TRUSTEDPARTS" ]; then
+ #echo "parts active"
+ for trusted in $(run-parts --list $TRUSTEDPARTS --regex '^.*\.gpg$'); do
+ #echo "part -> $trusted"
+ GPG="$GPG --keyring $trusted"
+ done
+ fi
+fi
+#echo "COMMAND: $GPG"
+
command="$1"
if [ -z "$command" ]; then
usage